diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobDeer.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobDeer.java
index e8cb5e1f4..8ba37c9ed 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobDeer.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobDeer.java
@@ -9,12 +9,14 @@ import net.minecraft.core.item.Items;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.season.Seasons;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3d;
+import org.joml.Vector3dc;
+import org.joml.primitives.AABBd;
 
 import java.util.ArrayList;
 import java.util.List;
@@ -83,7 +85,9 @@ public class MobDeer
         }
 
         if (player == null) {
-            final List<MobWolf> nearbyWolves = this.world.getEntitiesWithinAABB(MobWolf.class, AABB.fromPool(this.x, this.y, this.z, this.x + 1.0D, this.y + 1.0D, this.z + 1.0D).grow(8D, 4D, 8D));
+            AABBd checkBB = new AABBd(this.x, this.y, this.z, this.x + 1.0D, this.y + 1.0D, this.z + 1.0D);
+            MathHelper.aabbGrow(checkBB, 8D, 4D, 8D, checkBB);
+            final List<MobWolf> nearbyWolves = this.world.getEntitiesWithinAABB(MobWolf.class, checkBB);
             if (!nearbyWolves.isEmpty()) {
                 @NotNull MobWolf closestWolf = nearbyWolves.get(0);
                 double closestWolfDist = this.distanceToSqr(closestWolf);
@@ -108,10 +112,10 @@ public class MobDeer
 
     protected void getPathAwayFromPoint(final double x, final double z, final double pX, final double pZ) {
         final int scale = 10;
-        final @NotNull Vec3 vec = Vec3.fromPool(x - pX, 0.0, z - pZ).normalize().scale(scale);
+        final @NotNull Vector3d vec = new Vector3d(x - pX, 0.0, z - pZ).normalize().mul(scale);
 
-        final Vec3 safePoint = Vec3.fromPool(this.x + vec.x, this.y + vec.y, this.z + vec.z);
-        this.pathToEntity = this.world.getEntityPathToXYZ(this, MathHelper.floor(safePoint.x), MathHelper.floor(safePoint.y), MathHelper.floor(safePoint.z), 16F);
+        final Vector3dc safePoint = vec.add(this.x, this.y, this.z);
+        this.pathToEntity = this.world.getEntityPathToTilePos(this, new TilePos(safePoint), 16F);
     }
 
     @Override
@@ -330,7 +334,9 @@ public class MobDeer
         }
 
         private void syncToOtherDeer() {
-            final @NotNull List<@NotNull MobDeer> nearbyDeer = this.deer.world.getEntitiesWithinAABB(MobDeer.class, AABB.fromPool(this.deer.x, this.deer.y, this.deer.z, this.deer.x + 1.0D, this.deer.y + 1.0D, this.deer.z + 1.0D).grow(8D, 4D, 8D));
+            AABBd checkBB = new AABBd(this.deer.x, this.deer.y, this.deer.z, this.deer.x + 1.0D, this.deer.y + 1.0D, this.deer.z + 1.0D);
+            MathHelper.aabbGrow(checkBB, 8, 4, 8, checkBB);
+            final @NotNull List<@NotNull MobDeer> nearbyDeer = this.deer.world.getEntitiesWithinAABB(MobDeer.class, checkBB);
             for (final @NotNull MobDeer deer : nearbyDeer) {
                 if (!(deer.brainState instanceof SpookedBrainState)) {
                     deer.brainState = new TransitionalBrainState(deer, new SpookedBrainState(deer, this.threat), this.deer.random.nextInt(10));
@@ -387,7 +393,9 @@ public class MobDeer
         }
 
         private void syncToOtherDeer() {
-            final @NotNull List<@NotNull MobDeer> nearbyDeer = this.deer.world.getEntitiesWithinAABB(MobDeer.class, AABB.fromPool(this.deer.x, this.deer.y, this.deer.z, this.deer.x + 1.0D, this.deer.y + 1.0D, this.deer.z + 1.0D).grow(8D, 4D, 8D));
+            AABBd checkBB = new AABBd(this.deer.x, this.deer.y, this.deer.z, this.deer.x + 1.0D, this.deer.y + 1.0D, this.deer.z + 1.0D);
+            MathHelper.aabbGrow(checkBB, 8D, 4D, 8D, checkBB);
+            final @NotNull List<@NotNull MobDeer> nearbyDeer = this.deer.world.getEntitiesWithinAABB(MobDeer.class, checkBB);
             for (final @NotNull MobDeer deer : nearbyDeer) {
                 if (!(deer.brainState instanceof FleeingBrainState)) {
                     deer.brainState = new TransitionalBrainState(deer, new FleeingBrainState(deer, this.threat), this.deer.random.nextInt(5));
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
index 145551dd7..4ddad70a8 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
@@ -14,61 +14,58 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 import org.jetbrains.annotations.NotNull;
+import org.joml.primitives.AABBd;
 
 import java.util.Collection;
-import java.util.HashMap;
 import java.util.List;
-import java.util.Map;
 
 public class MobFireflyCluster extends MobFlying
-        implements AmbientCreature
-{
-	public static final int DATA_COLOR_ID = 16;
-	public static final int DATA_CLUSTER_SIZE_ID = 17;
-	public static final int DATA_COUNT_ID = 18;
-	public final int maxLifetime = 12000;
-	public final int maxClusterSize = 6;
+    implements AmbientCreature {
+    public static final int DATA_COLOR_ID = 16;
+    public static final int DATA_CLUSTER_SIZE_ID = 17;
+    public static final int DATA_COUNT_ID = 18;
+    public final int maxLifetime = 12000;
+    public final int maxClusterSize = 6;
     public final int slowUpdateCooldownMax = 500;
     public final int maxFireflyCountPerCluster = 64;
-	
+
     public int courseChangeCooldown;
     public int fireflyAge = 0;
-    
+
     private int syncedClusterSize = -1;
-    
+
     /**
      * Don't check for other entities every tick
      */
     private int slowUpdateCooldown;
-    
-    
-    public MobFireflyCluster(@NotNull final World world)
-    {
+
+
+    public MobFireflyCluster(@NotNull final World world) {
         super(world);
-        if(world.isClientSide) {
-        	setClusterSize(0);
-        	setFireflyCount(0);
-        }else {
-            setClusterSize(random.nextInt(maxClusterSize));
-            setFireflyCount(random.nextInt(5) + 3);
+        if (world.isClientSide) {
+            setClusterSize(0);
+            setFireflyCount(0);
+        } else {
+            setClusterSize(this.random.nextInt(this.maxClusterSize));
+            setFireflyCount(this.random.nextInt(5) + 3);
         }
         setSizeBasedOnClusterSize(getClusterSize());
 
-        courseChangeCooldown = 0;
-        moveSpeed = 0.05F;
-        fireImmune = true;
-        
+        this.courseChangeCooldown = 0;
+        this.moveSpeed = 0.05F;
+        this.fireImmune = true;
+
         // Give it a random cooldown so that not every check happens at the same time
-        slowUpdateCooldown = world.rand.nextInt(slowUpdateCooldownMax);
+        this.slowUpdateCooldown = world.rand.nextInt(this.slowUpdateCooldownMax);
     }
 
-	@Override
-	public void spawnInit() {
-		super.defineSynchedData();
-		Biome currentBiome = world.getBlockBiome((int) x, (int) y, (int) z);
-		FireflyColor color = null;
+    @Override
+    public void spawnInit() {
+        super.defineSynchedData();
+        Biome currentBiome = this.world.getBlockBiome((int) this.x, (int) this.y, (int) this.z);
+        FireflyColor color = null;
 
-		Collection<FireflyColor> colors = FireflyColor.fireFlyColors.values();
+        Collection<FireflyColor> colors = FireflyColor.fireFlyColors.values();
         for (FireflyColor fireFlyColor : colors) {
             Biome[] spawnBiomes = fireFlyColor.getSpawnBiomes();
             if (spawnBiomes == null) {
@@ -87,22 +84,18 @@ public class MobFireflyCluster extends MobFlying
             }
         }
 
-		if (color == null) {
-			color = FireflyColor.GREEN;
-		}
-
-		setColor(color);
-	}
-
-    protected FireflyColor getColourForBiome(Biome currentBiome){
-        for (FireflyColor c : FireflyColor.fireFlyColors.values())
-        {
-            if (c.getSpawnBiomes() != null)
-            {
-                for (Biome b : c.getSpawnBiomes())
-                {
-                    if (b == currentBiome)
-                    {
+        if (color == null) {
+            color = FireflyColor.GREEN;
+        }
+
+        setColor(color);
+    }
+
+    protected FireflyColor getColourForBiome(Biome currentBiome) {
+        for (FireflyColor c : FireflyColor.fireFlyColors.values()) {
+            if (c.getSpawnBiomes() != null) {
+                for (Biome b : c.getSpawnBiomes()) {
+                    if (b == currentBiome) {
                         return c;
                     }
                 }
@@ -112,68 +105,64 @@ public class MobFireflyCluster extends MobFlying
     }
 
     @Override
-    protected boolean makeStepSound()
-    {
+    protected boolean makeStepSound() {
         return false;
     }
 
     @Override
-    public void addAdditionalSaveData(@NotNull CompoundTag tag)
-    {
-		super.addAdditionalSaveData(tag);
-		tag.putByte("colour", entityData.getByte(16));
-		tag.putInt("FireflyAge", fireflyAge);
-		tag.putInt("FireflyCount", getFireflyCount());
-		tag.putInt("ClusterSize", getClusterSize());
+    public void addAdditionalSaveData(@NotNull CompoundTag tag) {
+        super.addAdditionalSaveData(tag);
+        tag.putByte("colour", this.entityData.getByte(16));
+        tag.putInt("FireflyAge", this.fireflyAge);
+        tag.putInt("FireflyCount", getFireflyCount());
+        tag.putInt("ClusterSize", getClusterSize());
     }
 
     @Override
-    public void readAdditionalSaveData(@NotNull CompoundTag tag)
-    {
-		super.readAdditionalSaveData(tag);
-		entityData.set(16, tag.getByte("colour"));
-		this.fireflyAge = tag.getInteger("FireflyAge");
-		setFireflyCount(tag.getInteger("FireflyCount"));
-		setClusterSize(tag.getInteger("ClusterSize"));
-		setPos(x, y, z); // Update bounding box
+    public void readAdditionalSaveData(@NotNull CompoundTag tag) {
+        super.readAdditionalSaveData(tag);
+        this.entityData.set(16, tag.getByte("colour"));
+        this.fireflyAge = tag.getInteger("FireflyAge");
+        setFireflyCount(tag.getInteger("FireflyCount"));
+        setClusterSize(tag.getInteger("ClusterSize"));
+        setPos(this.x, this.y, this.z); // Update bounding box
     }
 
     @Override
-    protected void defineSynchedData()
-    {
+    protected void defineSynchedData() {
         super.defineSynchedData();
 
-		entityData.define(DATA_COLOR_ID, (byte) 0, Byte.class);
-		entityData.define(DATA_CLUSTER_SIZE_ID, (byte) 0, Byte.class);
-		entityData.define(DATA_COUNT_ID, (byte) 0, Byte.class);
-    }
-
-	public void setColor(FireflyColor colour) {
-		entityData.set(DATA_COLOR_ID, (byte) colour.getId());
-	}
-
-	public FireflyColor getColor() {
-		int id = entityData.getByte(DATA_COLOR_ID);
-		return FireflyColor.fireFlyColors.get(id);
-	}
-	
-	public void setClusterSize(int clusterSize) {
-		entityData.set(DATA_CLUSTER_SIZE_ID, (byte) clusterSize);
-		setSizeBasedOnClusterSize(clusterSize);
-	}
-	
-	public int getClusterSize() {
-		return entityData.getByte(DATA_CLUSTER_SIZE_ID) & 0xFF;
-	}
-	
-	public void setFireflyCount(int fireflyCount) {
-		entityData.set(DATA_COUNT_ID, (byte) fireflyCount);
-	}
-	
-	public int getFireflyCount() {
-		return entityData.getByte(DATA_COUNT_ID) & 0xFF;
-	}
-    
+        this.entityData.define(DATA_COLOR_ID, (byte) 0, Byte.class);
+        this.entityData.define(DATA_CLUSTER_SIZE_ID, (byte) 0, Byte.class);
+        this.entityData.define(DATA_COUNT_ID, (byte) 0, Byte.class);
+    }
+
+    public void setColor(FireflyColor colour) {
+        this.entityData.set(DATA_COLOR_ID, (byte) colour.getId());
+    }
+
+    public FireflyColor getColor() {
+        int id = this.entityData.getByte(DATA_COLOR_ID);
+        return FireflyColor.fireFlyColors.get(id);
+    }
+
+    public void setClusterSize(int clusterSize) {
+        this.entityData.set(DATA_CLUSTER_SIZE_ID, (byte) clusterSize);
+        setSizeBasedOnClusterSize(clusterSize);
+    }
+
+    public int getClusterSize() {
+        return this.entityData.getByte(DATA_CLUSTER_SIZE_ID) & 0xFF;
+    }
+
+    public void setFireflyCount(int fireflyCount) {
+        this.entityData.set(DATA_COUNT_ID, (byte) fireflyCount);
+    }
+
+    public int getFireflyCount() {
+        return this.entityData.getByte(DATA_COUNT_ID) & 0xFF;
+    }
+
 //    private boolean isCourseTraversable(double waypointX, double waypointY, double waypointZ, double distanceFromEntity)
 //    {
 //
@@ -194,10 +183,9 @@ public class MobFireflyCluster extends MobFlying
 //    }
 
     @Override
-    protected void updateAI()
-    {
+    protected void updateAI() {
         //After 5 minutes, firefly changes color to match biome
-        
+
         // Set initial waypoint to random coordinate within 16 blocks of entity
 //        waypointX = posX + (double) ((rand.nextFloat() * 2.0F - 1.0F) * 16F);
 //        waypointY = posY + (double) ((rand.nextFloat() * 2.0F - 1.0F) * 5F);
@@ -227,23 +215,22 @@ public class MobFireflyCluster extends MobFlying
     }
 
     @Override
-    public boolean canSpawnHere()
-    {
+    public boolean canSpawnHere() {
         int x = MathHelper.floor(this.x);
-        int y = MathHelper.floor(bb.minY);
+        int y = MathHelper.floor(this.bb.minY);
         int z = MathHelper.floor(this.z);
-        int id = world.getBlockId(x, y - 1, z);
+        int id = this.world.getBlockId(x, y - 1, z);
 
-		if (shouldRemove()) return false;
-        if(world.getSavedLightValue(LightLayer.Block, x, y, z) > 0) return false;
-        if(world.getSavedLightValue(LightLayer.Sky, x, y, z) > random.nextInt(32))
+        if (shouldRemove()) return false;
+        if (this.world.getSavedLightValue(LightLayer.Block, x, y, z) > 0) return false;
+        if (this.world.getSavedLightValue(LightLayer.Sky, x, y, z) > this.random.nextInt(32))
             return false;
 
-        int blockLight = world.getBlockLightValue(x, y, z);
-        if(world.getCurrentWeather() != null && world.getCurrentWeather().isMobDaylightSpawnAllowed())
-            blockLight = blockLight/2;
+        int blockLight = this.world.getBlockLightValue(x, y, z);
+        if (this.world.getCurrentWeather() != null && this.world.getCurrentWeather().isMobDaylightSpawnAllowed())
+            blockLight = blockLight / 2;
 
-        return  blockLight <= 4 && (Blocks.blocksList[id] != null && Blocks.blocksList[id].hasTag(BlockTags.FIREFLIES_CAN_SPAWN)) && world.checkIfAABBIsClear(bb.grow(-2f, 0f, -2f));
+        return blockLight <= 4 && (Blocks.blocksList[id] != null && Blocks.blocksList[id].hasTag(BlockTags.FIREFLIES_CAN_SPAWN)) && this.world.checkIfAABBIsClear(MathHelper.aabbGrow(this.bb, -2f, 0f, -2f, new AABBd()));
     }
 
     @Override
@@ -266,233 +253,230 @@ public class MobFireflyCluster extends MobFlying
     }
 
     @Override
-    public boolean hurt(Entity attacker, int i, DamageType type)
-    {
+    public boolean hurt(Entity attacker, int i, DamageType type) {
         return false;
     }
 
     @Override
-	public String getLivingSound()
-    {
+    public String getLivingSound() {
         return "";
     }
 
     @Override
-    protected String getHurtSound()
-    {
+    protected String getHurtSound() {
         return "";
     }
 
     @Override
-    protected String getDeathSound()
-    {
+    protected String getDeathSound() {
         return "";
     }
 
     @Override
-    public void tick()
-    {
-		super.tick();
-		fireflyAge++;
-		// render those funky little buggy dudes
-		double dy = (random.nextFloat() * 2F - 1F) * (bbHeight);
-		double dx = (random.nextFloat() * 2F - 1F) * (bbWidth);
-		double dz = (random.nextFloat() * 2F - 1F) * (bbWidth);
-		
-		if (random.nextInt(Math.max(1, 10 - getFireflyCount())) == 0) {
-			world.spawnParticle(getColor().getParticleName(), x + dx, y + dy, z + dz, xd, yd, zd, 0, 256D);
-		}
-		
-		if(world.isClientSide) {
-			int clusterSize = getClusterSize();
-			if(syncedClusterSize != clusterSize) {
-				setSizeBasedOnClusterSize(clusterSize);
-				syncedClusterSize = clusterSize;
-				setPos(x, y, z); // Update bounding box
-			}
-		}
-		
-		slowUpdates();
-		
-		if(!world.isClientSide && shouldRemove()) {
-			remove();
-		}
-    }
-	private boolean shouldRemove(){
-		if(getFireflyCount() <= 0) {
-			return true;
-		}
-
-		if (!world.getWorldType().hasCeiling() && world.isDaytime()) {
-			return true;
-		}
-
-		if(fireflyAge > maxLifetime) {
-			return true;
-		}
-		return false;
-	}
-    
+    public void tick() {
+        super.tick();
+        this.fireflyAge++;
+        // render those funky little buggy dudes
+        double dy = (this.random.nextFloat() * 2F - 1F) * (this.bbHeight);
+        double dx = (this.random.nextFloat() * 2F - 1F) * (this.bbWidth);
+        double dz = (this.random.nextFloat() * 2F - 1F) * (this.bbWidth);
+
+        if (this.random.nextInt(Math.max(1, 10 - getFireflyCount())) == 0) {
+            this.world.spawnParticle(getColor().getParticleName(), this.x + dx, this.y + dy, this.z + dz, this.xd, this.yd, this.zd, 0, 256D);
+        }
+
+        if (this.world.isClientSide) {
+            int clusterSize = getClusterSize();
+            if (this.syncedClusterSize != clusterSize) {
+                setSizeBasedOnClusterSize(clusterSize);
+                this.syncedClusterSize = clusterSize;
+                setPos(this.x, this.y, this.z); // Update bounding box
+            }
+        }
+
+        slowUpdates();
+
+        if (!this.world.isClientSide && shouldRemove()) {
+            remove();
+        }
+    }
+
+    private boolean shouldRemove() {
+        if (getFireflyCount() <= 0) {
+            return true;
+        }
+
+        if (!this.world.getWorldType().hasCeiling() && this.world.isDaytime()) {
+            return true;
+        }
+
+        return this.fireflyAge > this.maxLifetime;
+    }
+
     private void slowUpdates() {
-		if(--slowUpdateCooldown > 0) {
-			return;
-		}
-		
-		setPos(x, y, z); // Update bounding box
-		if(world.isClientSide) {
-			return;
-		}
-		
-		merge();
-		if(getClusterSize() < maxClusterSize) {
-			expandIfPossible();
-		}
-		
-		int blockX = MathHelper.floor(x);
-		int blockY = MathHelper.floor(y);
-		int blockZ = MathHelper.floor(z);
-		FireflyColor colorForBiome = getColourForBiome(world.getBlockBiome(blockX, blockY, blockZ));
-		if(colorForBiome != this.getColor()) {
-			setColor(colorForBiome);
-		}
-    }
-    
-	private void merge() {
-		slowUpdateCooldown = slowUpdateCooldownMax;
-		
-		List<@NotNull MobFireflyCluster> nearbyFireflies = world.getEntitiesWithinAABB(MobFireflyCluster.class, bb.grow(2, 2, 2));
-		int nearbyCount = nearbyFireflies.size();
-		
-		if(nearbyCount == 1) {
-			// list only contains this entity
-			return;
-		}
-		
-		for(int i=0; i < nearbyCount; i++) {
-			MobFireflyCluster fireflyCluster = nearbyFireflies.get(i);
-			if(fireflyCluster == this) {
-				continue;
-			}
-			if(fireflyCluster.getColor() != this.getColor()) {
-				continue;
-			}
-			
-			// merge into the larger cluster
-			if(fireflyCluster.getFireflyCount() > this.getFireflyCount() || (fireflyCluster.getFireflyCount() == this.getFireflyCount() && world.rand.nextBoolean())) {
-				merge(this, fireflyCluster);
-			}else {
-				merge(fireflyCluster, this);
-			}
-			
-			if(!isAlive()) {
-				return;
-			}
-		}
-	}
-	
-	private void merge(MobFireflyCluster from, MobFireflyCluster to) {
-		if(from.getFireflyCount() + to.getFireflyCount() < maxFireflyCountPerCluster) {
-			to.setFireflyCount(to.getFireflyCount() + from.getFireflyCount());
-			from.remove();
-		}
-	}
-	
-	public void expandIfPossible() {
-		int prevSize = getClusterSize();
-		setSizeBasedOnClusterSize(prevSize + 1);
-		setPos(x, y, z); // Update bounding box
-		
-		if(world.getCollidingSolidBlockBoundingBoxes(this, bb).isEmpty()) {
-			setClusterSize(prevSize + 1);
-			return;
-		}
-		
-		setSizeBasedOnClusterSize(prevSize);
-		setPos(x, y, z); // Update bounding box
-	}
-	
-	public void setSizeBasedOnClusterSize(int clusterSize) {
-		setSize(0.1f + clusterSize, 0.1f + clusterSize * 0.6f);
-	}
+        if (--this.slowUpdateCooldown > 0) {
+            return;
+        }
+
+        setPos(this.x, this.y, this.z); // Update bounding box
+        if (this.world.isClientSide) {
+            return;
+        }
+
+        merge();
+        if (getClusterSize() < this.maxClusterSize) {
+            expandIfPossible();
+        }
+
+        int blockX = MathHelper.floor(this.x);
+        int blockY = MathHelper.floor(this.y);
+        int blockZ = MathHelper.floor(this.z);
+        FireflyColor colorForBiome = getColourForBiome(this.world.getBlockBiome(blockX, blockY, blockZ));
+        if (colorForBiome != this.getColor()) {
+            setColor(colorForBiome);
+        }
+    }
+
+    private void merge() {
+        this.slowUpdateCooldown = this.slowUpdateCooldownMax;
+
+        List<@NotNull MobFireflyCluster> nearbyFireflies = this.world.getEntitiesWithinAABB(MobFireflyCluster.class, MathHelper.aabbGrow(this.bb, 2, 2, 2, new AABBd()));
+        int nearbyCount = nearbyFireflies.size();
+
+        if (nearbyCount == 1) {
+            // list only contains this entity
+            return;
+        }
+
+        for (int i = 0; i < nearbyCount; i++) {
+            MobFireflyCluster fireflyCluster = nearbyFireflies.get(i);
+            if (fireflyCluster == this) {
+                continue;
+            }
+            if (fireflyCluster.getColor() != this.getColor()) {
+                continue;
+            }
+
+            // merge into the larger cluster
+            if (fireflyCluster.getFireflyCount() > this.getFireflyCount() || (fireflyCluster.getFireflyCount() == this.getFireflyCount() && this.world.rand.nextBoolean())) {
+                merge(this, fireflyCluster);
+            } else {
+                merge(fireflyCluster, this);
+            }
+
+            if (!isAlive()) {
+                return;
+            }
+        }
+    }
+
+    private void merge(MobFireflyCluster from, MobFireflyCluster to) {
+        if (from.getFireflyCount() + to.getFireflyCount() < this.maxFireflyCountPerCluster) {
+            to.setFireflyCount(to.getFireflyCount() + from.getFireflyCount());
+            from.remove();
+        }
+    }
+
+    public void expandIfPossible() {
+        int prevSize = getClusterSize();
+        setSizeBasedOnClusterSize(prevSize + 1);
+        setPos(this.x, this.y, this.z); // Update bounding box
+
+        if (this.world.getCollidingSolidBlockBoundingBoxes(this, this.bb).isEmpty()) {
+            setClusterSize(prevSize + 1);
+            return;
+        }
+
+        setSizeBasedOnClusterSize(prevSize);
+        setPos(this.x, this.y, this.z); // Update bounding box
+    }
+
+    public void setSizeBasedOnClusterSize(int clusterSize) {
+        setSize(0.1f + clusterSize, 0.1f + clusterSize * 0.6f);
+    }
 
     @Override
-    public int getMaxSpawnedInChunk()
-    {
+    public int getMaxSpawnedInChunk() {
         return 1;
     }
-    
+
     @Override
     public boolean canRide() {
-    	return false;
-    }
-
-	@Override
-	public boolean cycleVariant() {
-		MobFireflyCluster.FireflyColor color = MobFireflyCluster.FireflyColor.fireFlyColors.get(getColor().getId() + 1 % MobFireflyCluster.FireflyColor.fireFlyColors.size());
-		setColor(color == null ? MobFireflyCluster.FireflyColor.GREEN : color);
-		return true;
-	}
-
-	public static class FireflyColor {
-		public static Int2ObjectMap<FireflyColor> fireFlyColors = new Int2ObjectArrayMap<>();
-		public static FireflyColor GREEN = register(new FireflyColor(0, "fireflyGreen", new Biome[] {
-				Biomes.OVERWORLD_RAINFOREST,
-				Biomes.OVERWORLD_SWAMPLAND,
-				Biomes.OVERWORLD_FOREST,
-				Biomes.OVERWORLD_SEASONAL_FOREST
-		},
-				new float[]{0.7f, 0.95f, 0.35f}));
-		public static FireflyColor ORANGE = register(new FireflyColor(1, "fireflyOrange", new Biome[] {
-				Biomes.OVERWORLD_DESERT,
-				Biomes.OVERWORLD_OUTBACK,
-				Biomes.OVERWORLD_OUTBACK_GRASSY,
-				Biomes.OVERWORLD_CAATINGA,
-				Biomes.OVERWORLD_CAATINGA_PLAINS,
-		},
-				new float[]{1f, 0.9f, 0.58f}));
-		public static FireflyColor BLUE = register(new FireflyColor(2, "fireflyBlue", new Biome[] {
-				Biomes.OVERWORLD_TAIGA,
-				Biomes.OVERWORLD_TUNDRA,
-				Biomes.OVERWORLD_BOREAL_FOREST,
-				Biomes.OVERWORLD_GLACIER,
-				Biomes.DRIFT_DRIFT
-		},
-				new float[]{0.67f, 1f, 0.99f}));
-		public static FireflyColor RED = register(new FireflyColor(3, "fireflyRed", new Biome[] {
-				Biomes.NETHER_NETHER
-		},
-				new float[]{1f, 0.25f, 0.25f}));
-		public static FireflyColor register(FireflyColor color){
-			fireFlyColors.put(color.getId(), color);
-			return color;
-		}
-		private final int id;
-		private final String particleName;
-		private Biome[] spawnBiomes;
-		private float[] midColor;
-
-		public int getId()
-		{
-			return id;
-		}
-
-		public String getParticleName()
-		{
-			return particleName;
-		}
-
-		public Biome[] getSpawnBiomes()
-		{
-			return spawnBiomes;
-		}
-		public float[] getMidColor() {return midColor;}
-		public void setSpawnBiomes(Biome[] biomes){this.spawnBiomes = biomes;}
-		public FireflyColor(int id, String particleName, Biome[] spawnBiomes, float[] midColor)
-		{
-			this.id = id;
-			this.particleName = particleName;
-			this.spawnBiomes = spawnBiomes;
-			this.midColor = midColor;
-		}
-	}
+        return false;
+    }
+
+    @Override
+    public boolean cycleVariant() {
+        MobFireflyCluster.FireflyColor color = MobFireflyCluster.FireflyColor.fireFlyColors.get(getColor().getId() + 1 % MobFireflyCluster.FireflyColor.fireFlyColors.size());
+        setColor(color == null ? MobFireflyCluster.FireflyColor.GREEN : color);
+        return true;
+    }
+
+    public static class FireflyColor {
+        public static Int2ObjectMap<FireflyColor> fireFlyColors = new Int2ObjectArrayMap<>();
+        public static FireflyColor GREEN = register(new FireflyColor(0, "fireflyGreen", new Biome[]{
+            Biomes.OVERWORLD_RAINFOREST,
+            Biomes.OVERWORLD_SWAMPLAND,
+            Biomes.OVERWORLD_FOREST,
+            Biomes.OVERWORLD_SEASONAL_FOREST
+        },
+            new float[]{0.7f, 0.95f, 0.35f}));
+        public static FireflyColor ORANGE = register(new FireflyColor(1, "fireflyOrange", new Biome[]{
+            Biomes.OVERWORLD_DESERT,
+            Biomes.OVERWORLD_OUTBACK,
+            Biomes.OVERWORLD_OUTBACK_GRASSY,
+            Biomes.OVERWORLD_CAATINGA,
+            Biomes.OVERWORLD_CAATINGA_PLAINS,
+        },
+            new float[]{1f, 0.9f, 0.58f}));
+        public static FireflyColor BLUE = register(new FireflyColor(2, "fireflyBlue", new Biome[]{
+            Biomes.OVERWORLD_TAIGA,
+            Biomes.OVERWORLD_TUNDRA,
+            Biomes.OVERWORLD_BOREAL_FOREST,
+            Biomes.OVERWORLD_GLACIER,
+            Biomes.DRIFT_DRIFT
+        },
+            new float[]{0.67f, 1f, 0.99f}));
+        public static FireflyColor RED = register(new FireflyColor(3, "fireflyRed", new Biome[]{
+            Biomes.NETHER_NETHER
+        },
+            new float[]{1f, 0.25f, 0.25f}));
+
+        public static FireflyColor register(FireflyColor color) {
+            fireFlyColors.put(color.getId(), color);
+            return color;
+        }
+
+        private final int id;
+        private final String particleName;
+        private Biome[] spawnBiomes;
+        private final float[] midColor;
+
+        public int getId() {
+            return this.id;
+        }
+
+        public String getParticleName() {
+            return this.particleName;
+        }
+
+        public Biome[] getSpawnBiomes() {
+            return this.spawnBiomes;
+        }
+
+        public float[] getMidColor() {
+            return this.midColor;
+        }
+
+        public void setSpawnBiomes(Biome[] biomes) {
+            this.spawnBiomes = biomes;
+        }
+
+        public FireflyColor(int id, String particleName, Biome[] spawnBiomes, float[] midColor) {
+            this.id = id;
+            this.particleName = particleName;
+            this.spawnBiomes = spawnBiomes;
+            this.midColor = midColor;
+        }
+    }
 }
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobSquid.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobSquid.java
index 29ad4c86d..32cf64749 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobSquid.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobSquid.java
@@ -2,10 +2,9 @@ package net.minecraft.core.entity.animal;
 
 import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Items;
-import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
@@ -129,7 +128,7 @@ public class MobSquid extends MobWaterAnimal
     @Override
     public void trySuffocate(){
         if (isSpecial()) return;
-        if(isAlive() && !isUnderLiquid(Material.water) && canBreatheUnderwater())
+        if(isAlive() && !isUnderLiquid(Materials.WATER) && canBreatheUnderwater())
         {
             airSupply--;
             if(airSupply == -20)
@@ -177,9 +176,9 @@ public class MobSquid extends MobWaterAnimal
             if (isTouchingBlock && isInWater() && !world.isAirBlock((int) x, (int) (y + 1), (int) z) && !world.isAirBlock((int) x, (int) (y + 2), (int) z)){
                 ty = random.nextFloat() * 0.2F;
             } else {
-                if (upwardsBlock == null || upwardsBlock.getMaterial() != Material.water){
+                if (upwardsBlock == null || upwardsBlock.getMaterial() != Materials.WATER){
                     ty = -0.15F + random.nextFloat() * 0.2F; // Swim with bias down
-                } else if (downwardsBlock == null || downwardsBlock.getMaterial() != Material.water) {
+                } else if (downwardsBlock == null || downwardsBlock.getMaterial() != Materials.WATER) {
                     ty = -0.05F + random.nextFloat() * 0.4F; // Swim with bias up
                 } else {
                     ty = -0.1F + random.nextFloat() * 0.2F; // Swim with no bias
@@ -206,7 +205,7 @@ public class MobSquid extends MobWaterAnimal
                     for(int _z = minZ; _z <= maxZ; _z++)
                     {
                         Block<?> block = world.getBlock(_x, _y, _z);
-                        if(block != null && block.getMaterial() != Material.water)
+                        if(block != null && block.getMaterial() != Materials.WATER)
                         {
                             return true;
                         }
